#pragma once

#include "ofMain.h"
#include "particleSystem.hpp"
#include "greatWhole.hpp"
#include "avatar.hpp"
#include "ofxOsc.h"
#include "visitor.hpp"
#include "objectPhysics.hpp"
#include "particle.hpp"

    
    int WINDOWSIZE_WIDTH = 1000;
    int WINDOWSIZE_HEIGHT = 1000;




// *** SETUP OSC INFORMATION *** SETUP OSC INFORMATION ***

#define PORT 12345
#define HOST "xxx.xxx.xxx.xxx"

 


class ofApp : public ofBaseApp{
    
	public:
    
		void setup();
		void update();
		void draw();
		
		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y);
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void mouseEntered(int x, int y);
		void mouseExited(int x, int y);
		void windowResized(int w, int h);
		void dragEvent(ofDragInfo dragInfo);
		void gotMessage(ofMessage msg);
    
    
    int PARTICLE_COUNT;
    //+1 for every new Particle, -1 for every Particle that gets older than the defined maxLife
    int VISITOR_COUNT;
    //the visitor count will be fed with the nBlobs-value from incoming OSC messages
    int VISITOR_COUNT_LASTFRAME;


    
private:
    
    // *** OSC *** OSC *** OSC ***
    
    string oscMsg;
    ofxOscReceiver receiver;
    float timeSent, timeReceived;
    
    
    //Information about what is going on in the scene
    
    int nBlobs;         //count of the tracked visitors
    
    
    
    
    
    vector<Visitor*> visitors;
    
    vector<ParticleSystem*> particleSystems;
    
    GreatWhole dasGrosseGanze;
    
    
};



