//
//  particle.hpp
//
//  Created by Sebastian Holzki on 16.04.19.
//

#pragma once
#include <stdio.h>
#include "ofMain.h"





class Particle {
    
public:
    
    Particle();
    ~Particle();
    
    void setup(ofVec2f position);
    void update(float deltaT);
    void draw();
    
    float getMaxLife();
    float getAge();
    float getAgeNorm();
    
    
    void mapParticle();
    bool borderCollission();
    
    
    
    
private:
    
    ofVec2f velocity;
    ofVec2f position;

    float maxLife;
    float age;
    float size;
    float mass;
    
    ofColor color;
    
    
    int stele;
    //on which "stele" is the particle? --> will affect the movement (mapping), when it reaches borders of its "stele" !
    //if border 1/2/3/4 (<,>,v,^), then map particle
    
};
